function y=powc7(acr,fup,drop,h,wt,xd,xc,var,b,b0,a,cTotalN,pow,alpha,sides)
%Changed to compile on version 12 nEEDS ITS OWN VERSION OF FZERO NOW.
%Calculates power of Cox model. In is a parameter vector with the 
%following structure
%  fup            followup period
%  acr            accrual period
%  drop           attrition rate (currently as scalar)
%  h              hazard vector
%  wt m x 1       matrix of weights for each group of descrete covariates
%  xd m x ms      matrix of values for descrete covariates
%  xc m x mn      matrix of means of continuos covariates
%  var m x mn(mn+1)/2 matrix of variance covariance matrix of continuous covariates
%  b  (ms+mn) x 1 matrix of coeficients under HA
%  b0 (ms+mn) x 1 matrix of coeficients under HO
%  a  (ms+mn) x p contrast matrix
%  cTotalN        sample size
%  pow            power  
%  alpha          alpha level
%  sides          if p=1 then sidedness of test(tests for positive beta)
%  if cTotalN>0 and pow=0 find power
%  if cTotalN>0 and pow>0 find multiplyer of a(makes sense for simple a)
%  if cTotalN=0 and pow>0 find sample size
%  otherwise return -2
%  return -1 if array dimensions are wrong
%  return -3 if problems with alpha or sides
%  return -4 if problems with variance covariance matrix
%  return -5 asked for multiplyier when there is more than one contrast
global CHAZ HAZ DR CHAZ1 PCENS  
save('c:\powc9.mat');

%try
ka=acr;kf=fup;kk=ka+kf;%accrual period follow up period
DR=drop;%drop rate hazard rate for each period
swt=size(wt);
sxd=size(xd);
sxc=size(xc);
svar=size(var);
sb=size(b);
sb0=size(b0);
sa=size(a);
ms=sxd(2);%number of descrete covariates 
mn=sxc(2);% number of continuous covariates
mm=(ms+mn);%number of covariates
m=swt(1);%number of groups
df=sa(2);
mt=mm+1;
% The following code returns -1 if the input dimensions are wrong.
if (m~=sxd(1) & ms~=0)|(m~=sxc(1) & mn~=0)|(m~=svar(1) & mn~=0)...
     | mm~=min([sb(1) sb0(1) sa(1)]) |  mm~=max([sb(1) sb0(1) a(1)])|...
      svar(2)~=mn*(mn+1)/2|length(h)~=kk
  
   y=-1 ;
   return;
end
% This code classifies problem or returns error of inputs are wrong
if (cTotalN>0 & pow==0)
   cc=1;
else if (cTotalN>0 & pow>0 & pow<1 & df==1) 
      cc=2;
   else if (cTotalN>0 & pow>0 & pow<1 & df~=1) 
         y=-5;
         return;
      else if (cTotalN==0 & pow>0 & pow<1 )
            cTotalN=1;
            cc=3;
         else
            y=-2; 
            return
         end
      end 
   end
end

% This code checks for other errors
if (alpha<=0) | (alpha>1) | ~(sides==1 | sides==2)
   y=-3;
   return;
end
% This code corrects the problem of too few intervals.
if kk<4
    ka=ka*3;
    kf=kf*3;
    h=kron(diag(ones(kk,1)),ones(3,1)/3)*h;
    kk=ka+kf;
end
    wt=wt/sum(wt);%weights must sum to 1
if ms<mm
bc=b(ms+1:mm);%beta continuous
else
    bc=[];
end

v=zeros(mm,mm);
xx=[xd xc];
cvs=zeros(mn,mn);

ax=a;
hc=h'*triu(ones(kk,kk+1),1);

tdied=0;
v=zeros(mm,mm);
tvs=zeros(m,mn,mn);
for ii=1:m
   st=1;
   ee=mn;
   for j=1:mn
      tvs(ii,j,j:mn)=var(ii,st:ee);    
      st=ee+1;
      ee=st+mn-(j+1);
   end
   for j=2:mn
      for i=1:(j-1)
         tvs(ii,j,i)=tvs(ii,i,j);
      end
   end
   if det(reshape(tvs(ii,:,:),mn,mn))<=0 
       y=-4
       return
   end
end
for k=1:kk
   tmp=zeros(mt,mt);
   cDied=0;
   CHAZ=hc(k)+.5*h(k);
   if k>kf
      cens=(ka+kf-k+.5)/ka;
   else
      cens=1;
   end
   drop=exp(-DR*(k-.5));
   HAZ=h(k);
   drop1=exp(-DR*(k-1));
   if k>kf+1
      cens1=(ka+kf-k+1)/ka;
   else
      cens1=1;
   end
   CHAZ1=hc(k);
   if k>kf
      PCENS=1/(ka-(k-kf-1));
   else
      PCENS=0;
   end
   for ii=1:m
      cvs(:,:)=tvs(ii,:,:);
      us=[1 xx(ii,:)]';
      offset=xx(ii,:)*b;
      scale=sqrt(bc'*cvs*bc);
      if isempty(scale)
          scale=0;
      end
      ncvs=[zeros(ms+1,ms+1) zeros(ms+1,mn);zeros(mn,ms+1) cvs];
      
      et0=cens*drop*intl(offset,scale,0);
      et1=scale*et0+cens*drop*intl(offset,scale,1);
      et2=cens*drop*intl(offset,scale,2)+2*scale*et1+...
         -(scale^2)*et0;
     
     
      if scale~=0
         bs=(ncvs*([0 b'])')/scale;
      else
         bs=zeros(mm+1,1);
      end
      tmp=cTotalN*wt(ii)*(us*us'*et0+us*bs'*et1+bs*us'*et1+bs*bs'*et2+...
         (ncvs-bs*bs')*et0)+tmp;
      cDied=cDied+wt(ii)*cens1*drop1*intd(offset,scale);
   end
   den=tmp(1,1);
   v=v+ cTotalN*cDied*(tmp(2:mt,2:mt)./(den*ones(mm,mm))...
      -tmp(2:mt,1)*tmp(1,2:mt)./(ones(mm,mm)*den^2));
   tdied=cTotalN*cDied+tdied;%May not be used
end
   %zz=ax'*(b-b0)*pinv(ax'*pinv(v)*ax)*(b-b0)'*ax;
   zz=(b-b0)'*ax*pinv(ax'*pinv(v)*ax)*ax'*(b-b0);
   chi=sqrt(zz);
   if sides==2
   crit=norminv(1-alpha/2);
else 
    crit=norminv(1-alpha);
end

switch cc
case 1 %return Power
   if sides==1 & df==1
      y=normcdf(chi-crit);%NEED TO FIND;
   else
      y=1-ncx2cdf(chi2inv(1-alpha,df),df,zz);

   end
case 2 % Return Multiplyer
   if sides==1 & df==1
      y=(norminv(pow)+crit)/chi;
   else
      zz=a'*(b-b0)/sqrt(a'*pinv(v)*a);
      crit=norminv(1-alpha/2);
      y=(norminv(pow)+crit)/abs(zz);
     %The multiplier ignores the power from rejection in the wrong direction.
     %y=fzero('fmult1',y0,optimset('TolX',.001,'Display',[]),pow,crit,zz);

   end
case 3 % Return sample size
   if sides==1 & df==1
      y=ceil(((norminv(pow)+crit)/abs(chi) )^2);
   else
      crit=chi2inv(1-alpha,df);
      pp=norminv(pow);
      tmp1=crit-df+2*pp;tmp2=sqrt(2*pp*(2*crit-df+2*pp));
      m1=(tmp1-tmp2)/zz;
      m2=(tmp1+tmp2)/zz;
    %  y=ceil(fzero('fmult2',m2,.001,[],pow,crit,zz,df));
    % y=ceil(fzero('fmult2',m2,optimset('TolX',.001,'Display',[]),pow,crit,zz,df));
     y=findzero(m2,pow,crit,zz,df);
     y=y+.01
   end
   return
end
%catch
    %y=-6;
    %end

   
